#!/bin/sh

# declare globals
export GP_GADGET_DIR="/sys/kernel/config/usb_gadget/g1"
export GP_STRINGS_DIR="$GP_GADGET_DIR/strings/0x409"
export GP_CONFIGS_DIR="$GP_GADGET_DIR/configs/c.1"
export GP_FUNCTIONS_DIR="$GP_GADGET_DIR/functions"

# declare locals
PRINTER_FUNCS=$GP_FUNCTIONS_DIR/printer.0

SERIAL_NUM=`fw_printenv -n serialNumber`
PRINTER_NAME="DuraLabelKodiakMax"
PRINTER_SHARE_NAME=DLKMSHARE
PNP_STRING="MANUFACTURER:GraphicProductsInc;COMMAND SET:GPZL;MODEL:$PRINTER_NAME;COMMENT:None"
#PNP_STRING="MFG:GraphicProductsInc;CMD:GPZL;MODEL:$PRINTER_NAME;COMMENT:None"

GP_SHIP=`fw_printenv -n gpShip`
GP_MSD=`grep -i mountsharedfolder /home/root/.config/GraphicProducts/LabelForgePro.ini | cut -d'=' -f 2`

# install usb sysfs module
modprobe -i usb_f_printer

# define vid:pid
mkdir $GP_GADGET_DIR
echo 0x2DFC > $GP_GADGET_DIR/idVendor
echo 0x0004 > $GP_GADGET_DIR/idProduct


mkdir $GP_STRINGS_DIR
echo GraphicProductsInc > $GP_STRINGS_DIR/manufacturer
echo $SERIAL_NUM        > $GP_STRINGS_DIR/serialnumber
echo $PRINTER_NAME      > $GP_STRINGS_DIR/product


mkdir $GP_CONFIGS_DIR
echo 120 > $GP_CONFIGS_DIR/MaxPower

mkdir $PRINTER_FUNCS

echo 10          > $PRINTER_FUNCS/q_len
echo $PNP_STRING > $PRINTER_FUNCS/pnp_string

ln -s $PRINTER_FUNCS $GP_CONFIGS_DIR

if [ $GP_SHIP = 0 ] || [ -z $GP_SHIP ]; then
    /usr/libexec/serial_gadget.sh
fi

if [ "$GP_MSD" = "true" ]; then
    /usr/libexec/msd_gadget.sh $PRINTER_SHARE_NAME
fi

echo ci_hdrc.0 > $GP_GADGET_DIR/UDC

if [ "$GP_MSD" = "true" ]; then
    MYSTATE=`cat /sys/devices/platform/soc@0/soc@0:bus@32c00000/32e40000.usb/ci_hdrc.0/udc/ci_hdrc.0/state`

    if [ "$MYSTATE" != "configured" ]
    then
        mkdir /home/root/Desktop/$PRINTER_SHARE_NAME
        mount /home/root/internal_usb.img /home/root/Desktop/$PRINTER_SHARE_NAME
    fi
fi
